pchShow <-
function(extras = c("*", ".", "o", "O", "0", "+", "-", "|", "%", "#"), cex=3, col="black", bg="gray", coltext="black", cextext=1.2,  main="")
  {
nex <- length(extras)
np  <- 26 + nex
ipch <- 0:(np-1)
k <- floor(sqrt(np))
dd <- c(-1,1)/2
rx <- dd + range(ix <- ipch %/% k)
ry <- dd + range(iy <- 3 + (k-1)- ipch %% k)
pch <- as.list(ipch) # list with integers & strings
if(nex > 0) pch[26+ 1:nex] <- as.list(extras)
oldpar <- par(mar=c(0,0,0,0))
plot(rx, ry, type="n", axes=FALSE, xlab="", ylab="", main=main)
abline(v = ix, h = iy, col="lightgray", lty="dotted")
for(i in 1:np) 
  {
  pc <- pch[[i]]
  ## 'col' symbols with a 'bg'-colored interior (where available) :
  points(ix[i], iy[i], pch = pc, col = col, bg = bg, cex = cex) 
  if(cextext > 0) text(ix[i] - 0.3, iy[i], pc, col = coltext, cex = cextext)
  }
par(oldpar)
  }

## this function allows to suppress GhostScript errors like "Invalid BaseEncoding name..."
embedFonts2 <- function (file, format, outfile=file, fontpaths=character(), options=character(),
 ...) { # !
if (!is.character(file) || length(file) != 1L || !nzchar(file))
    stop("'file' must be a non-empty character string")
gsexe <- tools::find_gs_cmd()
if (!nzchar(gsexe))
    stop("GhostScript was not found")
if (.Platform$OS.type == "windows")
    gsexe <- shortPathName(gsexe)
suffix <- gsub(".+[.]", "", file)
if (missing(format))
    format <- switch(suffix, ps = , eps = "ps2write", pdf = "pdfwrite")
if (!is.character(format))
    stop("invalid output format")
grDevices:::check_gs_type(gsexe, format) # !
tmpfile <- tempfile("Rembed")
if (length(fontpaths))
    fontpaths <- paste0("-sFONTPATH=", shQuote(paste(fontpaths,
        collapse = .Platform$path.sep)))
args <- c(paste0("-dNOPAUSE -dBATCH -q -dAutoRotatePages=/None -sDEVICE=",
    format), paste0(" -sOutputFile=", shQuote(tmpfile)),
    fontpaths, options, shQuote(file))
ret <- system2(gsexe, args, ...) # !
if (ret != 0)
    stop(gettextf("status %d in running command '%s'", ret,
        cmd), domain = NA)
if (outfile != file)
    args[2] <- paste0(" -sOutputFile=", shQuote(outfile))
cmd <- paste(c(shQuote(gsexe), args), collapse = " ")
file.copy(tmpfile, outfile, overwrite = TRUE)
invisible(cmd)
}

pdfFonts(CM=Type1Font("CM", file.path("./fonts",
c(
"sfrm1000.afm",
"sfbx1000.afm",
"sfti1000.afm",
"sfbi1000.afm",
"cmsyase.afm"
))))

embedCMFonts <- function (file) embedFonts2(file,
 fontpaths=normalizePath("fonts"), stdout=NULL, stderr=NULL)

pdf.options(pointsize=15, family="CM", encoding="CP1251.enc")
